<script setup lang="ts">
  import { getSmallestThumbnailUrl } from '@shopware-pwa/helpers-next';
  import { OrderLineItem, CartProductItem, PropertyGroupOptionCart } from '@shopware-pwa/types';
  import { formatProductOptions } from '~/helpers/formatProductOptions';

  const props = defineProps<{
    data: OrderLineItem;
    readonly?: boolean;
    isPromoteCode?: boolean;
  }>();

  const lineItem = computed(() => props.data);
  const payload = lineItem.value.payload as CartProductItem;

  const options = computed(() =>
    formatProductOptions(
      payload.options?.map((option: PropertyGroupOptionCart) => ({
        group: option.group,
        name: option.option,
      })),
    ),
  );

  const dataCard = computed(() => ({
    name: lineItem.value.label,
    price: lineItem.value?.totalPrice,
    image: getSmallestThumbnailUrl(lineItem.value.cover) || lineItem.value?.cover?.url || '',
    options: options.value ?? undefined,
  }));

  const itemQuantity = computed(() => lineItem.value.quantity);
</script>

<template>
  <SwInlineProductCard :data="dataCard" :readonly="readonly">
    <template v-if="isPromoteCode" #product-image>
      <div
        class="border-border-default flex h-20 w-20 shrink-0 grow-0 items-center overflow-hidden rounded-md border"
      >
        <span class="i-sw-custom:promote-code text-(3xl/none emerald-900) mx-auto p-0" />
      </div>
    </template>
    <template #product-meta>
      <template v-if="!isPromoteCode">
        <SwQuantitySelector :readonly="readonly" :model-value="itemQuantity" />
      </template>
    </template>
  </SwInlineProductCard>
</template>
